/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.tali;

import com.mycompany.tali.util.Constants;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author maisner
 */
public class GeneLibrary {

  private static String[] patterns;

  static {
    try {
      patterns = fillLibrary();
    } catch (FileNotFoundException ex) {
      Logger.getLogger(GeneLibrary.class.getName()).log(Level.SEVERE, null, ex);
    }
  }

  /**
   * Naplní knihovnu genů z daného souboru.
   *
   * @return
   */
  private static String[] fillLibrary() throws FileNotFoundException {
    File f = new File(Constants.LIBRARY_FILE);
    Set<String> set = new HashSet<>();

    if (f.exists() && !f.isDirectory()) {
      try {
        BufferedReader br = new BufferedReader(new FileReader(f));
        String line;
        while ((line = br.readLine()) != null) {
          set.add(line.trim());
        }
        return set.toArray(new String[0]);
      }
      catch(IOException e){
        e.printStackTrace();
        return  null;
      }
    } else {
      return null;
    }
  }

  /**
   * Vytvoří novnou náhodnou sekvenci.
   *
   * @return
   */
  public static String generateNewSequence() {
    Random random = new Random();
    // První náhodná vazba (prázdný antigen je zbytečný)
    String antibody = patterns[random.nextInt(patterns.length)];
    int randomIndex;

    // Uživatelem určená hodnota pravděpodobnosti, že 
    // se k dané soustavě antigenů přidá další element.
    // Zaručuje variabilitu protilátek.
    while (random.nextDouble() < Constants.APPENDING_PROBABILITY) {
      // mextInt zaručuje, že pravý okraj je vyloučen.
      randomIndex = random.nextInt(patterns.length);
      antibody += "(.*)" + patterns[randomIndex];
    }
    
    return antibody;
  }

}
